#paintball deathmatch
#(c) by FiRe^

import host
import bf2
from game.scoringCommon import SCORE_MARKED, SCORE_TEAMMARKED, SCORE_DISQUALIFY, SCORE_TEAMDISQUALIFY


maxTickets1 = 100
maxTickets2 = 100
warmup = True
tmrCheck = None
tmrEnd = None
running = 0
punkte1 = 0
punkte2 = 0

def svCheck(data):
    global warmup, running
    host.rcon_invoke('sv.manDownTime 0')
    warmup = bool(int(host.rcon_invoke('sv.numPlayersNeededToStart')) >= bf2.playerManager.getNumberOfPlayers())
    if running == 20:
        for player in bf2.playerManager.getPlayers():
            if not player.isAlive():
                #player.setTimeToSpawn(9999)
                pass
    else:
        if running >= 0:
            running += 1


def init():
    host.registerGameStatusHandler(onGameStatusChanged)
    host.sh_setEnableCommander(0)
    
    host.registerHandler('TimeLimitReached', onTimeLimitReached, 1)
    print 'Paintball DM initialized'


def deinit():
    
    bf2.triggerManager.destroyAllTriggers()
    host.unregisterGameStatusHandler(onGameStatusChanged)
    print 'Paintball DM uninitialized'

def onGameStatusChanged(status):
    global maxTickets1, maxTickets2, tmrCheck, tmrEnd, running
    running = -1
    
    if status == bf2.GameStatus.Playing:
        tmrCheck = bf2.Timer(svCheck, 1, 1)
        tmrCheck.setRecurring(1)
        
	maxTickets1 = calcStartTickets(bf2.gameLogic.getDefaultTickets(1))
	maxTickets2 = calcStartTickets(bf2.gameLogic.getDefaultTickets(2))

	bf2.gameLogic.setTickets(1, 1)
	bf2.gameLogic.setTickets(2, 1)

	bf2.gameLogic.setTicketState(1, 0)
	bf2.gameLogic.setTicketState(2, 0)

	bf2.gameLogic.setTicketChangePerSecond(1, 0)
	bf2.gameLogic.setTicketChangePerSecond(2, 0)

	host.registerHandler('PlayerDeath', onPlayerDeath, 1)
	host.registerHandler('PlayerKilled', onPlayerKilled, 1)
	host.registerHandler('PlayerSpawn', onPlayerSpawn, 1)
	host.registerHandler('PlayerConnect', onPlayerConnect, 1)

	print 'Paintball DM loaded'
    else:
        bf2.triggerManager.destroyAllTriggers()
        minusTickets = {1: 0, 2: 0}
        if tmrCheck != None:
            tmrCheck.destroy()
            tmrCheck = None
        if tmrEnd != None:
            tmrEnd.destroy()
            tmrEnd = None



def calcStartTickets(mapDefaultTickets):
    return int(mapDefaultTickets * (bf2.serverSettings.getTicketRatio() / 100.0))

	
def onTimeLimitReached(value):
    team1tickets = bf2.gameLogic.getTickets(1)
    team2tickets = bf2.gameLogic.getTickets(2)
	
    if team1tickets > team2tickets:
	winner = 1
	victoryType = 3
    elif team2tickets > team1tickets:
	winner = 2
	victoryType = 3
    else:
        winner = 0
        victoryType = 0

    endRound(winner, victoryType)


def endRound2(data):
    global punkte1, punkte2
    punkte1 = 0
    punkte2 = 0
    host.sgl_endGame(data[0], data[1])


def endRound(winner, vt = 3):
    global punkte1, punkte2
    host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
    host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
    host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
    host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
    host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
    tmrEnd = bf2.Timer(endRound2, 7, 1, (winner, vt))

		
def onPlayerDeath(victim, vehicle):

    if victim == None or warmup:
        return
    victim.setTimeToSpawn(9999)

    foundLivingPlayer1 = False
    foundLivingPlayer2 = False
    for player in bf2.playerManager.getPlayers():
	if player != victim and player.isAlive():
            if player.getTeam() == 1:
                foundLivingPlayer1 = True
            else:
                foundLivingPlayer2 = True

    if not foundLivingPlayer1 and not foundLivingPlayer2:
        endRound(0)
    else:
        if not foundLivingPlayer1:
            endRound(1)
        if not foundLivingPlayer2:
            endRound(2)
    bf2.gameLogic.setTickets(1, getNumberOfPlayers(1))
    bf2.gameLogic.setTickets(2, getNumberOfPlayers(2))
    checkTickets()

def checkTickets(): 
    if bf2.gameLogic.getTickets(1) >= maxTickets1: 
        endRound(1)
    elif bf2.gameLogic.getTickets(2) >= maxTickets2:
        endRound(2)
      
  

def onPlayerKilled(victim, attacker, weapon, assists, object):
    global punkte1, punkte2
    if victim == None or warmup:
	return
    victim.killed = True

    vteam = victim.getTeam()
    if attacker != None:
        ateam = attacker.getTeam()

    vtickets = bf2.gameLogic.getTickets(vteam)
    atickets = bf2.gameLogic.getTickets(ateam)

    if (attacker == None):
        if ateam == 1:
            punkte1 -= 1
            host.rcon_invoke('game.sayAll \"Team Red-Member marked himself: Team Red -1 Points\"')
        if ateam == 2:
            punkte2 -= 1
            host.rcon_invoke('game.sayAll \"Team Blue-Member marked himself: Team Blue -1 Points\"')
        host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
    else:
        if ateam == vteam:
            if ateam == 1:
                punkte1 -= 1
                host.rcon_invoke('game.sayAll \"Team Red Teamkill: Team Red -1 Points\"')
            if ateam == 2:
                punkte2 -= 1
                host.rcon_invoke('game.sayAll \"Team Blue Teamkill: Team Blue -1 Points\"')
            host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')
        else:
            if ateam == 1:
                punkte1 += 5
                punkte2 -= 1
                host.rcon_invoke('game.sayAll \"Team Red marked rival: Team Red +5 Points; Team Blue -1 Points\"')
            if ateam == 2:
                punkte2 += 5
                punkte1 -= 1
                host.rcon_invoke('game.sayAll \"Team Blue marked rival: Team Blue +5 Points; Team Red -1 Points\"')
            host.rcon_invoke('game.sayAll \"--> Team Red Points: C1101' + str(punkte1) + 'C1101 <|> Team Blue Points: C1101' + str(punkte2) + 'C1101\"')

    for p in bf2.playerManager.getPlayers(): 
        if p.getTeam() == 1: 
            p.score.score = punkte1
        if p.getTeam() == 2:
            p.score.score = punkte2 


def onPlayerConnect(player):
    player.score.score = bf2.gameLogic.getTickets(player.getTeam())

def onPlayerSpawn(player, soldier):
    global running
    if running < 0:
        running = 0
    player.score.score = bf2.gameLogic.getTickets(player.getTeam())
    player.killed = False

    
def getNumberOfPlayers(team): 
     count = 0 
     for p in bf2.playerManager.getPlayers(): 
          if (p.getTeam() == team) and p.isAlive() and not p.isManDown(): 
               count += 1
     return count

